/*************************************************************************
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 * Copyright 2008 by Sun Microsystems, Inc.
 *
 * OpenOffice.org - a multi-platform office productivity suite
 *
 * $RCSfile: unocrsrhelper.hxx,v $
 * $Revision: 1.12 $
 *
 * This file is part of OpenOffice.org.
 *
 * OpenOffice.org is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3
 * only, as published by the Free Software Foundation.
 *
 * OpenOffice.org is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3 for more details
 * (a copy is included in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU Lesser General Public License
 * version 3 along with OpenOffice.org.  If not, see
 * <http://www.openoffice.org/license.html>
 * for a copy of the LGPLv3 License.
 *
 ************************************************************************/
#ifndef _UNOCRSRHELPER_HXX
#define _UNOCRSRHELPER_HXX

#include <com/sun/star/beans/XPropertyState.hpp>
#include <unocrsr.hxx>


struct SfxItemPropertyMap;
class SwPaM;
class SwDoc;

namespace com{ namespace sun{ namespace star{
	namespace uno{
		class Any;
	}
    namespace beans{
        struct PropertyValue;
    }
}}}
/* -----------------------------14.12.00 15:06--------------------------------

 ---------------------------------------------------------------------------*/
namespace SwUnoCursorHelper
{
	sal_Bool 					getCrsrPropertyValue(const SfxItemPropertyMap* pMap
										, SwPaM& rPam
										, com::sun::star::uno::Any *pAny
                                        , com::sun::star::beans::PropertyState& eState
                                        , const SwTxtNode* pNode = 0 );

	void 						GetCurPageStyle(SwPaM& rPaM, String &rString);

	inline sal_Bool 			IsStartOfPara(SwPaM& rUnoCrsr)
										{ return rUnoCrsr.GetPoint()->nContent == 0;}
	inline sal_Bool 			IsEndOfPara(SwPaM& rUnoCrsr)
										{ return rUnoCrsr.GetCntntNode() &&
											rUnoCrsr.GetPoint()->nContent == rUnoCrsr.GetCntntNode()->Len();}

	void 						resetCrsrPropertyValue(const SfxItemPropertyMap* pMap, SwPaM& rPam);
	void 						InsertFile(SwUnoCrsr* pUnoCrsr,
                                    const String& rURL,
                                    const ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue >& rOptions
                                    ) throw( com::sun::star::lang::IllegalArgumentException, com::sun::star::io::IOException, com::sun::star::uno::RuntimeException );

	void 						getNumberingProperty(
									SwPaM& rPam,
									com::sun::star::beans::PropertyState& eState,
									com::sun::star::uno::Any *pAny );

	void 						setNumberingProperty(
									const com::sun::star::uno::Any& rValue,
									SwPaM& rPam);

	sal_Int16 					IsNodeNumStart(
									SwPaM& rPam,
									com::sun::star::beans::PropertyState& eState);

    sal_Bool    DocInsertStringSplitCR(  SwDoc &rDoc,
                                    const SwPaM &rNewCursor, const String &rText );
    void    makeRedline( SwPaM& rPaM, const ::rtl::OUString& RedlineType, 
            const ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue >& RedlineProperties ) 
                throw (::com::sun::star::lang::IllegalArgumentException, ::com::sun::star::uno::RuntimeException);

} // namespace SwUnoCursorHelper

#endif
